package org.gcube.informationsystem.resourceregistry.types.relations;

import org.gcube.informationsystem.resourceregistry.api.exceptions.ResourceRegistryException;
import org.gcube.informationsystem.resourceregistry.api.exceptions.types.SchemaViolationException;
import org.gcube.informationsystem.resourceregistry.contexts.security.SecurityContext;
import org.gcube.informationsystem.resourceregistry.types.entities.ResourceTypeDefinitionManagement;
import org.gcube.informationsystem.types.reference.entities.ResourceType;
import org.gcube.informationsystem.types.reference.relations.IsRelatedToType;

import com.arcadedb.remote.RemoteDatabase;

/**
 * @author Luca Frosini (ISTI - CNR)
 */
public class IsRelatedToTypeDefinitionManagement
		extends RelationTypeDefinitionManagement<ResourceTypeDefinitionManagement,ResourceType> {
	
	public IsRelatedToTypeDefinitionManagement() {
		super(ResourceType.class);
		this.typeName = IsRelatedToType.NAME;
	}
	
	public IsRelatedToTypeDefinitionManagement(SecurityContext securityContext, RemoteDatabase database)
			throws ResourceRegistryException {
		super(securityContext, database, ResourceType.class);
		this.typeName = IsRelatedToType.NAME;
	}
	
	@Override
	protected ResourceTypeDefinitionManagement newTargetEntityManagement() throws ResourceRegistryException {
		ResourceTypeDefinitionManagement rtdm = new ResourceTypeDefinitionManagement();
		rtdm.setWorkingContext(getWorkingContext());
		rtdm.setDatabase(database);
		return rtdm;
	}
	
	@Override
	public void sanityCheck() throws SchemaViolationException, ResourceRegistryException {
		// Nothing to do
	}
}
